/***********************************************************************/
/*                                                                     */
/*  FILE        :InfraRed.c                                            */
/*  DATE        :Sat, Jul 11, 2009                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :24                                                    */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.15).    */
/*                                                                     */
/***********************************************************************/

#include    "TA_Firmware\TAF_00D.h"
#include    "TA_Firmware\TAF_00P.h"
#include    "TA_Firmware\Msg_00D.h"
#include 	"sfr24.h"

#define ROBOPROMEM	0 //FLASH1
#define HWID_COUNT	MSG_HWID_RF_SELF

typedef int far (*entrypoint)(void);
const static entrypoint progs[3] = {(entrypoint)0x80100, (entrypoint)0xA0100, (entrypoint)0x50100};
static long A3msg;
static long A3count = 0L;

#define TWOPHASE

void initA3counter()
{//mode is event counter
#ifdef TWOPHASE
	ta3mr = 0xD1; //mult by 4, free run
//	ta3mr = 0x51; //normal, free run
	udf |= 0x40;
#else
	ta3mr = 0x51; //use ta3out pin as dir, falling edges, free run
	udf &= ~0x40;
#endif
  	trgsr &= ~0x30;
	pd7_6 = 0; //program pin as input
	ta3 = 0x8000; //start in the middle
	ta3s = 1; //start counting
	ta3 = 0x8000; //start in the middle, free running => not sure that reload value ever gets loaded
//at present interrupt is not used, otherwise initialize it here
}

int readA3diff()
{ 	static unsigned old =0x8000;
	unsigned val = ta3;
	int diff = ta3 - old; //this is unambiguous as long as the absolute difference is less than half the maximum count (<0x8000)
	/* proof:
		if no underfow or overflow: trivial
		if old value positive and new value overflows, the new value is 0x10000 too low which makes no difference.
		example old=0x7000 and the increase = 0x3000, the new value will be 0xa000 which is negative.
		new - old is 0xa000 - 0x7000 = 0xa000 + 0x9000 = 0x13000 which reduces to 0x3000 which is the correct increase
	*/
	old = val;
	A3count += diff;
	return diff;
}

long make_message(char far *id, int val)//scramble message name
{ long rv = 0;
  int i;
  if (id)
    for (i=0; i<3 && id[i]; i++)
	{ rv *= 40;
	  if (id[i]=='!')
	    rv += 39;
	  else if (id[i]=='+')
	    rv += 37;
	  else if (id[i]=='-')
	    rv += 38;
	  else if (id[i]>='0' && id[i]<='9')
	    rv += id[i]-'0'+27;
	  else if (id[i]>='A' && id[i]<='Z')
	    rv += id[i]-'A'+1;
	  else if (id[i]>='a' && id[i]<='z')
	    rv += id[i]-'a'+1;
	}
  return ((long)val<<16)|rv;
}

void far timerint()//1ms interrupt
{ static char time = 0;
    
  if (++time >= 100)
  { long val = readA3diff();
  	time = 0;
	if (val != 0)
	  SendFtMessage(HWID_COUNT, 9, A3msg|(val<<16), 0 /*ms*/, MSG_SEND_NORMAL /*MSG_SEND_OTHER_THAN_LAST*/);
  }
}

void main(void)
{
	A3msg = make_message("cnt", 0);
	initA3counter();
	SetFt1msTimerTickAddress((void far *())timerint);
	progs[ROBOPROMEM]();
}
